# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-

# Ubuntu System Tests
# Copyright (C) 2016 Canonical
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

from autopilot.exceptions import StateNotFoundError
from ubuntu_system_tests.helpers import context
from ubuntu_system_tests.helpers.input_manager import input_manager

TRANSFER_INDICATOR = 'indicator-transfer'


class IndicatorsFactory:

    @staticmethod
    def get_indicators_page(name):
        date_time_indicator = context.shared.unity.main_window.select_single(
            objectName='indicator-datetime-panelItem')
        x, y, w, h = date_time_indicator.get_properties()['globalRect']

        input_manager.pointer.drag(
            x + w/2, y + h/2, x + w/2,
            context.shared.unity.main_window.get_properties()['height']/2)

        indicators_list = context.shared.unity.main_window.wait_select_single(
            objectName='indicatorsContentListView', visible=True, enabled=True)

        while not indicators_list.get_properties()['atXBeginning']:
            input_manager.keyboard.press_and_release('LEFT')

        while not indicators_list.get_properties()['atXEnd']:
            try:
                indicators_list.select_single(
                    objectName='{}-page'.format(name),
                    visible=True,
                    enabled=True)
                break
            except StateNotFoundError:
                input_manager.keyboard.press_and_release('RIGHT')

        return context.shared.unity.main_window.select_single(
            'PanelMenuPage', visible=True)
