# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-

# Ubuntu System Tests
# Copyright (C) 2016 Canonical
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import fixtures

from ubuntu_system_tests.helpers.input_manager import input_manager


class SetPointingDevice(fixtures.Fixture):
    """ Fixture used to set a default pointing device for the
    test execution.
    """

    def setUp(self):
        super().setUp()
        input_manager.set_pointing_device()
        self.addCleanup(input_manager.release_pointing_device)


class SetKeyboard(fixtures.Fixture):
    """ Fixture used to set a default keyboard for the
    test execution.
    """

    def setUp(self):
        super().setUp()
        input_manager.set_keyboard()
        self.addCleanup(input_manager.release_keyboard)
