# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-

#
# Ubuntu System Tests
# Copyright (C) 2016 Canonical
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

# import unittest
#
# from unittest.mock import patch
#
# from ubuntu_system_tests.helpers.input_manager import (
#     input_manager,
#     InputManager
# )
#
#
# class TestInputManager(unittest.TestCase):
#
#     def test_input_manager_class_is_singleton(self):
#         a = InputManager()
#         b = InputManager()
#         self.assertEqual(a, b)
#
#     def test_get_pointing_device_returns_always_same_instance(self):
#         function = '_InputManager__create_pointing_device'
#         with patch.object(InputManager, function, return_value=object()):
#             a = input_manager.pointer
#         with patch.object(InputManager, function, return_value=object()):
#             b = input_manager.pointer
#         with patch.object(InputManager, function, return_value=object()):
#             c = InputManager().pointer
#         with patch.object(InputManager, function, return_value=object()):
#             d = InputManager().pointer
#         self.assertEqual(a, b)
#         self.assertEqual(b, c)
#         self.assertEqual(c, d)
#
#     def test_get_keyboard_returns_always_same_instance(self):
#         function = '_InputManager__create_keyboard'
#         with patch.object(InputManager, function, return_value=object()):
#             a = input_manager.keyboard
#         with patch.object(InputManager, function, return_value=object()):
#             b = input_manager.keyboard
#         with patch.object(InputManager, function, return_value=object()):
#             c = InputManager().keyboard
#         with patch.object(InputManager, function, return_value=object()):
#             d = InputManager().keyboard
#         self.assertEqual(a, b)
#         self.assertEqual(b, c)
#         self.assertEqual(c, d)
#
#     def test_input_manager_releases_pointing_device(self):
#         function = '_InputManager__create_pointing_device'
#         with patch.object(InputManager, function, return_value=object()):
#             a = input_manager.pointer
#         self.assertIsNotNone(a)
#         input_manager.release_pointing_device()
#         with patch.object(InputManager, function, return_value=object()):
#             b = input_manager.pointer
#         self.assertIsNotNone(b)
#         self.assertNotEqual(a, b)
#
#     def test_input_manager_releases_keyboard(self):
#         function = '_InputManager__create_keyboard'
#         with patch.object(InputManager, function, return_value=object()):
#             a = input_manager.keyboard
#         self.assertIsNotNone(a)
#         input_manager.release_keyboard()
#         with patch.object(InputManager, function, return_value=object()):
#             b = input_manager.keyboard
#         self.assertIsNotNone(b)
#         self.assertNotEqual(a, b)
#
#     @patch('autopilot.platform.model', return_value='Desktop')
#     @patch('autopilot.input.Pointer')
#     @patch('autopilot.input.Mouse.create', return_value='Mouse')
#     @patch('autopilot.input.Touch.create', return_value='Touch')
#     def test_input_manager_gets_mouse_pointer_for_desktop(
#             self, touch, mouse, pointer, platform):
#         input_manager.pointer
#         pointer.assert_called_once_with(device='Mouse')
#
#     @patch('autopilot.platform.model', return_value='Any')
#     @patch('autopilot.input.Pointer')
#     @patch('autopilot.input.Mouse.create', return_value='Mouse')
#     @patch('autopilot.input.Touch.create', return_value='Touch')
#     def test_input_manager_gets_touch_pointer_for_non_desktop(
#             self, touch, mouse, pointer, platform):
#         input_manager.pointer
#         pointer.assert_called_once_with(device='Touch')
#
#     def tearDown(self):
#         input_manager.release_keyboard()
#         input_manager.release_pointing_device()
