
# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-

# Ubuntu System Tests
# Copyright (C) 2015 Canonical
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
from ubuntu_system_tests.helpers import platform
from ubuntu_system_tests.helpers.indicators.network.cpo import (
    NetworkIndicatorPage)

from ubuntu_system_tests.helpers import system_settings
from ubuntu_system_tests.tests.indicators import base

CELLULAR_SETTINGS_PAGE = 'cellularPage'
WIFI_SETTINGS_PAGE = 'wifiPage'


class NetworkIndicatorTestCase(base.IndicatorTestCaseBase):

    def setUp(self):
        super().setUp(NetworkIndicatorPage.name)

    def test_ethernet_settings_item_open_correct_page(self):
        """
        1. Drag down the network indicator
        2. Tap 'Cellular settings...'
        3. Ensure cellular settings open
        """
        self.indicator_page.open_network_settings()
        settings_app = system_settings.get_system_settings_proxy()
        expected_page = WIFI_SETTINGS_PAGE if \
            platform.get_device_name() is not 'desktop' \
            else CELLULAR_SETTINGS_PAGE
        system_settings.ensure_settings_page_visible(settings_app,
                                                     expected_page)
